<template>
<div>
    <default-spinner-component
      :loading-message="loadingMessage"
      v-if="loadingData"/>
    <v-container v-if="dataReturned">
      <v-layout row
        justify-space-between>
        <v-card class="defaultCardBackground"
          style="width:100%;height:auto;margin-top:-10px;">
          <query-menu/>
        </v-card>
      </v-layout>
      <div v-if="noSalesDataFound"
        style="font-size: 60px;color: #809ba9;text-align: center;margin-top: 10%;">
        No sales data found
      </div>
      <v-layout v-bind="gridResponsiveness"
        v-if="salesDataFound"
        row
        justify-space-between>
        <v-flex xs4
          style="margin-top:20px;">
          <v-card class="defaultCardBackground"
            style="width:90%;margin:0 auto;height:200px;position:relative;">
            <sales-percentage/>
          </v-card>
        </v-flex>
        <v-flex xs4
          style="margin-top:20px;">
          <v-card class="defaultCardBackground"
            style="width:90%;margin:0 auto;height:200px;">
            <sales-summary/>
          </v-card>
        </v-flex>
        <v-flex xs4
          style="margin-top:20px;">
          <v-card class="defaultCardBackground"
            style="width:90%;margin:0 auto;height:200px;">
            <most-and-least-sold-product-component/>
          </v-card>
        </v-flex>
      </v-layout>
      <v-layout v-bind="gridResponsiveness"
        v-if="salesDataFound"
        row
        justify-space-between>
        <v-flex xs7
          style="margin-top:20px;">
          <v-card class="defaultCardBackground"
            style="width:95%;margin:0 auto;height:250px;">
            <sales-result-table/>
          </v-card>
        </v-flex>
        <v-flex xs5
          style="margin-top:20px;">
          <v-card class="defaultCardBackground"
            style="width:95%;margin:0 auto;height:250px;">
            <seller-sales-report/>
          </v-card>
        </v-flex>
      </v-layout>
      <v-layout v-if="salesDataFound"
        row
        justify-space-between>
      </v-layout>
    </v-container>
  </div>
</template>
<script>
import moment from 'moment'
import SalesResultTable from './salesResultTable.vue'
import DefaultSpinnerComponent from './../common/spinner.vue'
import MostAndLeastSoldProductComponent from './mostAndLeastSold.vue'
import SellerSalesReport from './sellerSalesReport.vue'
import SalesSummary from './salesSummary.vue'
import SalesPercentage from './salesPercentage.vue'
import QueryMenu from './queryMenu.vue'
export default {
  name: 'ReportComponent',
  components: {
    DefaultSpinnerComponent,
    SalesResultTable,
    MostAndLeastSoldProductComponent,
    SellerSalesReport,
    SalesSummary,
    SalesPercentage,
    QueryMenu
  },
  data: () => ({
    salesData: [],
    loadingMessage: 'Loading report ...',
    loadingData: false,
    dataReturned: false
  }),
  computed: {
    noSalesDataFound () {
      return this.$store.state.reportModule.noSalesDataFound
    },
    salesDataFound () {
      return this.$store.state.reportModule.salesDataFound
    },
    gridResponsiveness () {
      const gridResponsiveness = {}
      if (this.$vuetify.breakpoint.sm || this.$vuetify.breakpoint.xs) gridResponsiveness.column = true
      return gridResponsiveness
    }
  },
  created () {
    this.loadingData = true
    let startTime = moment(new Date()).startOf('day').format('YYYY-MM-DDTHH:mm:ss.000') + 'Z'
    let endTime = moment(new Date()).endOf('day').format('YYYY-MM-DDTHH:mm:ss.000') + 'Z'

    this.$store.dispatch('VIEW_ITEM_REQUEST', {startTime, endTime})
      .then(response => {
        setTimeout(() => {
          this.loadingData = false
          this.dataReturned = true
        }, 2000)
      })
      .catch(error => {
        this.loadingData = false
        this.dataReturned = false
        this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error in getting report: ' + error)
      })
  }
}
</script>
